; Processor	  : z80	[]
; Target assembler: Zilog Macro	Assembler
; Segment type:	Pure code


;-----------------------------------------------------------------------------
; AS-Funktionen
;-----------------------------------------------------------------------------

; obere 8 Bit: hi(CONBU)
hi              function x,(x>>8)&255

; untere 8 Bit: lo(CONBU)
lo              function x, x&255

		cpu	z80

;------------------------------------------------------------------------------
; EMRSIM 	U881-Simulator 
;------------------------------------------------------------------------------

; LC80
; enum PORTS
CTC0:		 equ 0ECh		; System CTC0
CTC1:		 equ 0EDh		; System CTC1
CTC2:		 equ 0EEh		; System CTC2
CTC3:		 equ 0EFh		; System CTC3
SEGMENT:	 equ 0F4h		; AUSGABE-PORT SEGMENTANSTEUERUNG
DIGITAP:	 equ 0F5h		; DIGITANST. UND TASTENMATRIX,TAPE
PIO1AC:		 equ 0F6h		; PIO1 A Kommando
PIO1BC:		 equ 0F7h		; PIO1 B Kommando
USERPORT:	 equ 0F8h
PIO2AC:		 equ 0F9h		; PIO2 A Kommando
KEYIN:		 equ 0FAh		; EINGAENGE TASTEN-ABFRAGE, USERPORT
PIO2BC:		 equ 0FBh		; PIO2 B Kommando
; enum RAM
DATLED:		 equ 23F2h		; Std-Anzeigespeicher Daten
ADRLED:		 equ 23F4h		; Std-Anzeigespeicher Adressen
; enum MONITOR
SOU1K:		 equ 35Eh		; 1 kHz, 80ms
SOU2K:		 equ 367h		; 2 kHz, 80ms
SOUND:		 equ 376h		; Tonsignalausgabe
DAK1:		 equ 45Ah		; Anzeige bis Tastendruck
DAK2:		 equ 483h		; Anzeige 1x
ADRSDP:		 equ 4B7h		; Eintragen von	4 Ziffern in Adressanz.speicher
DADP:		 equ 4C3h		; Eintragen von	2 Ziffern in Datenanz.speicher
ONESEG:		 equ 4CAh		; Umwandlung 1 Ziffer zur Anzeige
TWOSEG:		 equ 4D9h		; Umwandlung 2 Ziffern zur Anzeige
MUSIC:		 equ 4EEh		; Spielen von Musik
xDAK1:		 equ 85Ah		; Anzeige bis Tastendruck
xDAK2:		 equ 883h		; Anzeige 1x
xADRSDP:	 equ 8B7h		; Eintragen von	4 Ziffern in Adressanz.speicher
xDADP:		 equ 8C3h		; Eintragen von	2 Ziffern in Datenanz.speicher
xONESEG:	 equ 8CAh		; Umwandlung 1 Ziffer zur Anzeige
xTWOSEG:	 equ 8D9h		; Umwandlung 2 Ziffern zur Anzeige
xMUSIC:		 equ 8EEh		; Spielen von Musik
; enum KEYS
KEY_PLUS:	 equ 10h		; Taste	PLUS
KEY_MINUS:	 equ 11h		; Taste	MINUS
KEY_EX:		 equ 12h		; Taste	EX
KEY_DAT:	 equ 14h		; Taste	DAT
KEY_ADR:	 equ 19h		; Taste	ADR
KEY_ST:		 equ 1Eh		; Taste	ST
KEY_LD:		 equ 1Fh		; Taste	LD


;------------------------------------------------------------------------------
; EMRSIM 	U881-Simulator 
;------------------------------------------------------------------------------

		org 800h
		
		jp	sim

;------------------------------------------------------------------------------
; Z8-Opcode-Tablle Befehlscode 00 bis FF (-> 256 Adressen)
;------------------------------------------------------------------------------

; Tabelle OP-Codes
tab_opc:	dw c00_dec		
		dw c01_dec
		dw c02_add
		dw c03_add
		dw c04_add
		dw c05_add
		dw c06_add
		dw c07_add
		dw cx8_ld
		dw cx9_ld
		dw cxa_djnz
		dw c0b_jr
		dw cxc_ld
		dw c0d_jp
		dw cxe_inc
		dw c0f			; spezial code: single step
		dw c10_rlc
		dw c11_rlc
		dw c12_adc
		dw c13_adc
		dw c14_adc
		dw c15_adc
		dw c16_adc
		dw c17_adc
		dw cx8_ld
		dw cx9_ld
		dw cxa_djnz
		dw c1b_jr
		dw cxc_ld
		dw c1d_jp
		dw cxe_inc
		dw c1f			; spezial code: trace
		dw c20_inc
		dw c21_inc
		dw c22_sub
		dw c23_sub
		dw c24_sub
		dw c25_sub
		dw c26_sub
		dw c27_sub
		dw cx8_ld
		dw cx9_ld
		dw cxa_djnz
		dw c2b_jr
		dw cxc_ld
		dw c2d_jr
		dw cxe_inc
		dw c2f			; spezial code: autorun
		dw c30_jp
		dw c31_srp
		dw c32_sbc
		dw c33_sbc
		dw c34_sbc
		dw c35_sbc
		dw c36_sbc
		dw c37_sbc
		dw cx8_ld
		dw cx9_ld
		dw cxa_djnz
		dw c3b_jr
		dw cxc_ld
		dw c3d_jp
		dw cxe_inc
		dw c3f			; spezial code: registeranzeige
		dw c40_da
		dw c41_da
		dw c42_or
		dw c43_or
		dw c44_or
		dw c45_or
		dw c46_or
		dw c47_or
		dw cx8_ld
		dw cx9_ld
		dw cxa_djnz
		dw c4b_jr
		dw cxc_ld
		dw c4d_jp
		dw cxe_inc
		dw cxx_noop		; no op, halt
		dw c50_pop
		dw c51_pop
		dw c52_and
		dw c53_and
		dw c54_and
		dw c55_and
		dw c56_and
		dw c57_and
		dw cx8_ld
		dw cx9_ld
		dw cxa_djnz
		dw c5b_jr
		dw cxc_ld
		dw c5d_jr
		dw cxe_inc
		dw cxx_noop		; no op, halt
		dw c60_com
		dw c61_com
		dw c62_tcm
		dw c63_tcm
		dw c64_tcm
		dw c65_tcm
		dw c66_tcm
		dw c67_tcm
		dw cx8_ld
		dw cx9_ld
		dw cxa_djnz
		dw c6b_jr
		dw cxc_ld
		dw c6d_jp
		dw cxe_inc
		dw cxx_noop		; no op, halt
		dw c70_push
		dw c71_push
		dw c72_tm
		dw c73_tm
		dw c74_tm
		dw c75_tm
		dw c76_tm
		dw c77_tm
		dw cx8_ld
		dw cx9_ld
		dw cxa_djnz
		dw c7b_jr
		dw cxc_ld
		dw c7d_jp
		dw cxe_inc
		dw cxx_noop		; no op, halt
		dw c80_decw
		dw c81_decw
		dw c82_lde
		dw c83_ldei
		dw cxx_noop		; no op, halt
		dw cxx_noop		; no op, halt
		dw cxx_noop		; no op, halt
		dw cxx_noop		; no op, halt
		dw cx8_ld
		dw cx9_ld
		dw cxa_djnz
		dw c8b_jr
		dw cxc_ld
		dw c8d_jp
		dw cxe_inc
		dw c8f_di
		dw c90_rl
		dw c91_rl
		dw c92_lde
		dw c93_ldei
		dw cxx_noop		; no op, halt
		dw cxx_noop		; no op, halt
		dw cxx_noop		; no op, halt
		dw cxx_noop		; no op, halt
		dw cx8_ld
		dw cx9_ld
		dw cxa_djnz
		dw c9b_jr
		dw cxc_ld
		dw c9d_jp
		dw cxe_inc
		dw c9f_ei
		dw ca0_incw
		dw ca1_incw
		dw ca2_cp
		dw ca3_cp
		dw ca4_cp
		dw ca5_cp
		dw ca6_cp
		dw ca7_cp
		dw cx8_ld
		dw cx9_ld
		dw cxa_djnz
		dw cab_jr
		dw cxc_ld
		dw cad_jp
		dw cxe_inc
		dw caf_ret
		dw cb0_clr
		dw cb1_clr
		dw cb2_xor
		dw cb3_xor
		dw cb4_xor
		dw cb5_xor
		dw cb6_xor
		dw cb7_xor
		dw cx8_ld
		dw cx9_ld
		dw cxa_djnz
		dw vbb_jr
		dw cxc_ld
		dw cbd_jp
		dw cxe_inc
		dw cbf_iret
		dw cc0_rrc
		dw cc1_rrc
		dw c82_lde
		dw c83_ldei
		dw cxx_noop		; no op, halt
		dw cxx_noop		; no op, halt
		dw cxx_noop		; no op, halt
		dw cc7_ld
		dw cx8_ld
		dw cx9_ld
		dw cxa_djnz
		dw ccb_jr
		dw cxc_ld
		dw ccd_jr
		dw cxe_inc
		dw ccf_rcf
		dw cd0_sra
		dw cd1_sra
		dw c92_lde
		dw c93_ldei
		dw cd4_call
		dw cxx_noop		; no op, halt
		dw cd6_call
		dw cd7_ld
		dw cx8_ld
		dw cx9_ld
		dw cxa_djnz
		dw cdb_jr
		dw cxc_ld
		dw cdd_jp
		dw cxe_inc
		dw cdf_scf
		dw ce0_rr
		dw ce1_rr
		dw cxx_noop		; no op, halt
		dw ce3_ld
		dw ce4_ld
		dw ce5_ld
		dw ce6_ld
		dw ce7_ld
		dw cx8_ld
		dw cx9_ld
		dw cxa_djnz
		dw ceb_jr
		dw cxc_ld
		dw ced_jp
		dw cxe_inc
		dw cef_ccf
		dw cf0_swap
		dw cf1_swap
		dw cxx_noop		; no op, halt
		dw cf3_ld
		dw cxx_noop		; no op, halt
		dw cf5_ld
		dw cxx_noop		; no op, halt
		dw cxx_noop		; no op, halt
		dw cx8_ld
		dw cx9_ld
		dw cxa_djnz
		dw cfb_jr
		dw cxc_ld
		dw cfd_jp
		dw cxe_inc
		dw cff_nop

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

sim:		ld	a, (autorun)	; 0F=autorun, sonst 1F
		cp	0Fh		; single step
		jr	z, sim1		; System-Register laden
		ld	a, 1Fh		; trace
		ld	(autorun), a

sim1:		ld	hl, sysregtab	; System-Register laden
		ld	de, sysregister	; Reg. F0..FF
		ld	bc, 10h
		ldir
		ld	hl, unk_A69	; step-routine in RAM umladen
		ld	de, unk_230F	; zieladr.
		ld	bc, next-unk_A69	; Lnge
		ldir

		ld	bc, (startadr)	; startadr z8-programm
		ld	hl, emrprog	; Anfangsadresse EPROM im RAM-Bereich (2400)
		add	hl, bc
		ld	(current), hl	; aktuelle Adr.	(im Z80-Adressraum)
		ld	hl, 0
		ld	(stepcnt), hl	; schrittzhler

sim2:		ld	iy, (current)	; atuelle Adresse
		ld	a, (iy+0)	; Befehlscode
		ld	(unk_2316), a	; in step+6 einpatchen (Parameter f. Next)
		call	step
		ld	hl, (stepcnt)
		inc	hl
		ld	(stepcnt), hl
		ld	ix, DATLED	; Std-Anzeigespeicher Daten
		ld	a, (autorun)	; 0F=autorun, sonst 1F
		cp	0Fh		; single step
		jr	nz, sim3	; nein
		call	DAK1		; sonst Anzeige
		jr	sim2

sim3:		cp	1Fh		; trace?
		jr	nz, sim2	; nein
		xor	a
		out	(DIGITAP), a	; DIGITANST. UND TASTENMATRIX,TAPE
		dec	a
		out	(DIGITAP), a	; DIGITANST. UND TASTENMATRIX,TAPE
		call	DAK2
		jr	sim2


;------------------------------------------------------------------------------
; Step
; liegt im RAM, da der Opcode f. NEXT verndert werden muss
; (Keine bergabe via Register, sondern im Code als Folgebyte)
;------------------------------------------------------------------------------

unk_A69:

		phase 230fh
;adr 230e/230f -> adr. bei Anzeige in special code 3fh

c3f_register:	equ	$-1		; Registernr fr Anzeige bei code 3F
unk_230F:	db  hi(register)	; Adr 230E = aktuelles Register f. 3F
		

step:		call	flags		; flags	setzen
		call	next		; nchsten OP-Code ausfhren
unk_2316:	db	0		; hier wird gepatcht: db opcode
		ld	b, hi(register)
		ld	hl, DATLED	; Std-Anzeigespeicher Daten
		ld	de, unk_2007	; auszugebendes	Register
		ld	a, (de)
		ld	c, a		; c=register
		ld	a, (bc)		; wert
		call	TWOSEG
		dec	de
		ld	a, (de)
		ld	c, a
		ld	a, (bc)
		call	TWOSEG
		dec	de
		ld	a, (de)
		ld	c, a
		ld	a, (bc)
		jp	ports
		db    0

		dephase

;------------------------------------------------------------------------------
; next
; nchsten OP-Code ausfhren
; Aufruf: call next; db opcode
;------------------------------------------------------------------------------

next:		pop	hl		; ret-adr
		inc	hl		; +1
		push	hl		; wieder auf stack
		dec	hl		; ret-adr orig.
		dec	sp		; Platz auf Stack
		dec	sp		; f. zustzliche Ret-Adr
		push	af
		ld	e, (hl)		; OP-Code
		ld	d, 0
		ld	hl, tab_opc	; Tabelle OP-Codes
		add	hl, de
		add	hl, de
		ld	e, (hl)		; OP-Code-Adr.
		inc	hl
		ld	d, (hl)
		ex	de, hl
		pop	af
		ex	(sp), hl	; auf Stack
		ret			; ausfhren

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

;Z8-Flags in Z80-Flags umwandeln
; flags	setzen

flags:					; sub_B1F:loc_B5Dp ...
		push	hl
		push	bc
		ld	hl, reg_Flags	; FLAGS	register
		ld	bc, 0
		bit	2, (hl)		; Half-carry flag
		jr	z, flags1
		set	4, c
flags1:		bit	3, (hl)		; Decimal-adjust flag
		jr	z, flags2
		set	1, c
flags2:		bit	4, (hl)		; Overflow flag
		jr	z, flags3
		set	2, c
flags3:		bit	5, (hl)		; Sign flag
		jr	z, flags4
		set	7, c
flags4:		bit	7, (hl)		; Carry	flag
		jr	z, flags5
		set	0, c
flags5:		bit	6, (hl)		; Zero flag
		jr	z, flags6
		set	6, c
flags6:		push	bc
		pop	af		; setze	F-Register
		pop	bc
		pop	hl
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

sub_AD5:	push	af
		pop	bc
		ld	hl, reg_Flags	; FLAGS	register
		res	2, (hl)		; Half-carry flag
		bit	4, c
		jr	z, loc_AE2
		set	2, (hl)
loc_AE2:	push	bc
		pop	af		; setze	F-Register
sub_AE4:	push	af
		pop	bc
		ld	hl, reg_Flags
		res	4, (hl)
		bit	2, c
		jr	z, loc_AF1
		set	4, (hl)
loc_AF1:	push	bc
		pop	af		; setze	F-Register
loc_AF3:	push	af
		pop	bc
		ld	hl, reg_Flags
		res	7, (hl)
		bit	0, c
		jr	z, loc_B00
		set	7, (hl)
loc_B00:	push	bc
		pop	af		; setze	F-Register
loc_B02:	push	af
		pop	bc
		ld	hl, reg_Flags
		res	5, (hl)
		bit	7, c
		jr	z, loc_B0F
		set	5, (hl)
loc_B0F:	push	bc
		pop	af		; setze	F-Register
		push	af
		pop	bc
		ld	hl, reg_Flags
		res	6, (hl)
		bit	6, c
		jr	z, locret_B1E
		set	6, (hl)
locret_B1E:	ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

sub_B1F:	ld	h, hi(register)
		ld	a, (iy+0)
		and	0F0h ; ''
		rlca
		rlca
		rlca
		rlca
		ld	l, a
		ld	a, (reg_RP)	; Register Pointer
		and	0F0h ; ''
loc_B30:	or	l
		ld	l, a
		jr	loc_B5D

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

loc_B34:	call	sub_B1F

p_R:		ld	d, hi(register)
		ld	e, (iy+1)
		ld	a, e
		and	0F0h ; ''
		cp	0E0h ; ''
		jr	nz, loc_B50
		ld	a, (reg_RP)	; Register Pointer
		and	0F0h ; ''
		ld	b, a
		ld	a, (iy+1)
		and	0Fh
		or	b
		ld	e, a
loc_B50:	jr	loc_B5D

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

loc_B52:	call	p_R
		ex	de, hl
		inc	iy
		call	p_R
		dec	iy
loc_B5D:	call	flags		; flags	setzen
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

p_R_R:		call	loc_B52
		ex	de, hl
		jr	loc_B5D

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

p_R_IM:		call	p_R
		ex	de, hl
		push	iy
		pop	de
		inc	de
		inc	de
		jr	loc_B5D

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

sub_B72:	ld	h, hi(register)
		ld	d, h
		ld	a, (reg_RP)	; Register Pointer
		and	0F0h ; ''
		ld	l, a
		ld	e, a
		ld	a, (iy+1)
		and	0Fh
		or	e
		ld	e, a
		ld	a, (iy+1)
		and	0F0h ; ''
		rlca
		rlca
		rlca
		rlca
		jr	loc_B30

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

loc_B8E:	inc	iy
		ld	(current), iy	; aktuelle Adr.	(im Z80-Adressraum)
sub_B94:	inc	iy
		ld	(current), iy	; aktuelle Adr.	(im Z80-Adressraum)
loc_B9A:	inc	iy
		ld	(current), iy	; aktuelle Adr.	(im Z80-Adressraum)
		ret

;------------------------------------------------------------------------------
; special emremu: emr-monitor
;------------------------------------------------------------------------------

c3f:		call	c3f_6		; Anzeige Register-Nr und Wert
		ld	hl, ADRLED+2
		call	c3f_7		; Punkte setzen, DAK1
		ld	hl, c3f_register ; Registernr fr Anzeige bei code 3F
		cp	KEY_DAT		; "DAT"
		jr	z, c3f_3
		cp	KEY_EX		; "EX"
		jp	z, loc_B9A	; Ende,	nchster OPCode
		cp	KEY_PLUS	; "+"
		jr	nz, c3f_1
		inc	(hl)		; nchstes Register
		jr	c3f_3

c3f_1:		cp	KEY_MINUS	; "-"
		jr	nz, c3f_2	; Tasten 0..F
		dec	(hl)		; vorheriges Register
		jr	c3f_3

c3f_2:		call	c3f_8		; Tetrade einfgen
		jr	c3f		; weiter

c3f_3:		call	c3f_6		; Anzeige Register-Nr und Wert
		ld	hl, DATLED	; Std-Anzeigespeicher Daten
		call	c3f_7		; Punkte setzen	und DAK1
		ld	hl, c3f_register ; Registernr fr Anzeige bei code 3F
		cp	KEY_ADR		; "ADR"
		jr	z, c3f		; weiter
		cp	KEY_EX		; "EX"
		jp	z, loc_B9A	; Ende,	nchster Opcode
		cp	KEY_PLUS	; "+"
		jr	nz, c3f_4
		inc	(hl)		; nchstes Register
		jr	c3f_3

c3f_4:		cp	KEY_MINUS	; "-"
		jr	nz, c3f_5
		dec	(hl)		; vorheriges Register
		jr	c3f_3

c3f_5:		ld	hl, (c3f_register) ; Registernr	fr Anzeige bei	code 3F
		call	c3f_8
		jr	c3f_3

; Anzeige Register-Nr und Wert
c3f_6:		ld	hl, ADRLED
		xor	a
		ld	(hl), a
		inc	hl
		ld	(hl), a
		inc	hl
		ld	a, (c3f_register) ; Registernr fr Anzeige bei code 3F
		call	TWOSEG
		ld	de, (c3f_register) ; Registernr	fr Anzeige bei	code 3F
		ld	a, (de)		; registerwert
		call	DADP
		ret

; Punkte setzen	und DAK1
c3f_7:		set	4, (hl)
		inc	hl
		set	4, (hl)
		ld	ix, DATLED
		call	DAK1
		ret

; Tetrade einschieben
c3f_8:		sla	(hl)
		sla	(hl)
		sla	(hl)
		sla	(hl)
		or	(hl)
		ld	(hl), a
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

c00_dec:	call	p_R
		ex	de, hl
		dec	(hl)
loc_C28:	call	sub_AE4
		jp	sub_B94

c01_dec:	call	p_R
		ex	de, hl
		ld	l, (hl)
		dec	(hl)
		jr	loc_C28

c20_inc:	call	p_R
		ex	de, hl
		inc	(hl)
		jr	loc_C28

c21_inc:	call	p_R
		ex	de, hl
		ld	l, (hl)
		inc	(hl)
		jr	loc_C28

cxe_inc:	call	sub_B1F
		inc	(hl)

loc_C49:	call	sub_AE4
		jp	loc_B9A

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

cef_ccf:	ccf
		jr	loc_C49

c8f_di:		ld	hl, reg_IMR	; Interrupt mask reg.
		res	7, (hl)
		jr	loc_C49

c9f_ei:		ld	hl, reg_IMR	; Interrupt mask reg.
		set	7, (hl)
		jr	loc_C49

cff_nop:	jr	loc_C49

cxx_noop:	halt			; no op, halt

ccf_rcf:	scf
		jr	cef_ccf

cdf_scf:	scf
		jr	loc_C49

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

c04_add:	call	p_R_R
loc_C6C:	ld	a, (de)
		add	a, (hl)
loc_C6E:	ld	(hl), a
		call	sub_AD5
		res	3, (hl)
		jp	loc_B8E

c05_add:	call	p_R_R
		ld	a, (de)
		ld	e, a
		jr	loc_C6C

c14_adc:	call	p_R_R
loc_C81:	ld	a, (de)
		adc	a, (hl)
		jr	loc_C6E

c15_adc:	call	p_R_R
		ld	a, (de)
		ld	e, a
		jr	loc_C81

c24_sub:	call	p_R_R
loc_C8F:	ld	a, (de)
		ld	b, a
		ld	a, (hl)
		sub	b
loc_C93:	ld	(hl), a
		call	sub_AD5
		set	3, (hl)
		jp	loc_B8E

c25_sub:	call	p_R_R
		ld	a, (de)
		ld	e, a
		jr	loc_C8F

c34_sbc:	call	p_R_R
loc_CA6:	ld	a, (de)
		ld	b, a
		ld	a, (hl)
		sbc	a, b
		jr	loc_C93

c35_sbc:	call	p_R_R
		ld	a, (de)
		ld	e, a
		jr	loc_CA6

c06_add:	call	p_R_IM
		jr	loc_C6C

c07_add:	call	p_R_IM
		ld	l, (hl)
		jr	loc_C6C

c16_adc:	call	p_R_IM
		jr	loc_C81

c17_adc:	call	p_R_IM
		ld	l, (hl)
		jr	loc_C81

c26_sub:	call	p_R_IM
		jr	loc_C8F

c27_sub:	call	p_R_IM
		ld	l, (hl)
		jr	loc_C8F

c36_sbc:	call	p_R_IM
		jr	loc_CA6

c37_sbc:	call	p_R_IM
		ld	l, (hl)
		jr	loc_CA6

c46_or:		call	p_R_IM
		jr	loc_D2F

c47_or:		call	p_R_IM
		ld	l, (hl)
		jr	loc_D2F

c56_and:	call	p_R_IM
		jr	loc_D44

c57_and:	call	p_R_IM
		ld	l, (hl)
		jr	loc_D44

c66_tcm:	call	p_R_IM
		jr	loc_D52

c67_tcm:	call	p_R_IM
		ld	l, (hl)
		jr	loc_D52

c76_tm:		call	p_R_IM
		jr	loc_D63

c77_tm:		call	p_R_IM
		ld	l, (hl)
		jr	loc_D63

ca6_cp:		call	p_R_IM
		jr	loc_D7F

ca7_cp:		call	p_R_IM
		ld	l, (hl)
		jr	loc_D7F

cb6_xor:	call	p_R_IM
		jr	loc_D71

cb7_xor:	call	p_R_IM
		ld	l, (hl)
		jr	loc_D71

ce6_ld:		call	p_R_IM
		jr	loc_D93

ce7_ld:		call	p_R_IM
		ld	l, (hl)
		jr	loc_D93

c44_or:		call	p_R_R
loc_D2F:	ld	a, (de)
		or	(hl)
loc_D31:	ld	(hl), a
loc_D32:	call	loc_B02
		res	4, (hl)
		jp	loc_B8E

c45_or:		call	p_R_R
		ld	a, (de)
		ld	e, a
		jr	loc_D2F

c54_and:	call	p_R_R
loc_D44:	ld	a, (de)
		and	(hl)
		jr	loc_D31

c55_and:	call	p_R_R
		ld	a, (de)
		ld	e, a
		jr	loc_D44

c64_tcm:	call	p_R_R
loc_D52:	ld	a, (de)
		ld	b, a
		ld	a, (hl)
		cpl
		and	b
		jr	loc_D32

c65_tcm:	call	p_R_R
		ld	a, (de)
		ld	e, a
		jr	loc_D52

c74_tm:		call	p_R_R
loc_D63:	ld	a, (de)
		and	(hl)
		jr	loc_D32

c75_tm:		call	p_R_R
		ld	a, (de)
		ld	e, a
		jr	loc_D63

cb4_xor:	call	p_R_R
loc_D71:	ld	a, (de)
		xor	(hl)
		jr	loc_D31

cb5_xor:	call	p_R_R
		ld	a, (de)
		ld	e, a
		jr	loc_D71

ca4_cp:		call	p_R_R
loc_D7F:	ld	a, (de)
		ld	b, a
		ld	a, (hl)
		cp	b
		call	sub_AE4
		jp	loc_B8E

ca5_cp:		call	p_R_R
		ld	a, (de)
		ld	e, a
		jr	loc_D7F

ce4_ld:		call	p_R_R
loc_D93:	ld	a, (de)
		ld	(hl), a
		jp	loc_B8E

ce5_ld:		call	p_R_R
		ld	a, (de)
		ld	e, a
		jr	loc_D93

cf5_ld:		call	p_R_R
		ld	l, (hl)
		jr	loc_D93

cx8_ld:		call	loc_B34
		ld	a, (de)
loc_DA9:	ld	(hl), a

loc_DAA:	jp	sub_B94

cx9_ld:		call	loc_B34
		ld	a, (hl)
		ld	(de), a
		jr	loc_DAA

cxc_ld:		call	sub_B1F
		ld	a, (iy+1)
		jr	loc_DA9

c31_srp:	ld	a, (iy+1)
		ld	(reg_RP), a	; Register RP
		jr	loc_DAA

cb0_clr:	call	p_R
		xor	a
		ld	(de), a
		jr	loc_DAA

cb1_clr:	call	p_R
		ld	a, (de)
		ld	e, a
		xor	a
		ld	(de), a
		jr	loc_DAA

c70_push:	ld	hl, reg_SPL	; Stack	Pointer
		dec	(hl)
		ld	l, (hl)
		call	p_R

loc_DDC:	ld	a, (de)
		ld	(hl), a
		jp	sub_B94

c50_pop:	ld	hl, reg_SPL	; Stack	Pointer
		ld	l, (hl)
		call	p_R
		ld	a, (hl)
loc_DE9:	ld	(de), a
		ld	hl, reg_SPL	; Stack	Pointer
		inc	(hl)
		jp	sub_B94

c71_push:	ld	hl, reg_SPL	; Stack	Pointer
		dec	(hl)
		ld	l, (hl)
		call	p_R
		ld	a, (de)
		ld	e, a
		jr	loc_DDC

c51_pop:	ld	hl, reg_SPL	; Stack	Pointer
		ld	l, (hl)
		ld	b, (hl)
		call	p_R
		ld	a, (de)
		ld	e, a
		ld	a, b
		jr	loc_DE9

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

c90_rl:		call	f_R
loc_E0D:	rlc	(hl)
loc_E0F:	dec	(hl)
		inc	(hl)
		call	sub_AE4
		jp	sub_B94

c91_rl:		call	f_R
		ld	l, (hl)
		jr	loc_E0D
c10_rlc:	call	f_R
loc_E20:	rl	(hl)
		jr	loc_E0F

c11_rlc:	call	f_R
		ld	l, (hl)
		jr	loc_E20

ce0_rr:		call	f_R
loc_E2D:	rrc	(hl)
		jr	loc_E0F

ce1_rr:		call	f_R
		ld	l, (hl)
		jr	loc_E2D

cc0_rrc:	call	f_R
loc_E3A:	rr	(hl)
		jr	loc_E0F
cc1_rrc:	call	f_R
		ld	l, (hl)
		jr	loc_E3A

cd0_sra:	call	f_R
loc_E47:	sra	(hl)
		jr	loc_E0F

cd1_sra:	call	f_R
		ld	l, (hl)
		jr	loc_E47

cf0_swap:	call	f_R
loc_E54:	rlc	(hl)
		rlc	(hl)
		rlc	(hl)
		rlc	(hl)
		jr	loc_E0F
cf1_swap:	call	f_R
		ld	l, (hl)
		jr	loc_E54


;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

f_R:		call	flags		; flags	setzen
		call	p_R
		ex	de, hl
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

cxa_djnz:	call	sub_B1F
		call	sub_B94
		ld	a, (hl)
		dec	a
		ld	(hl), a
		jr	z, loc_E85
		call	sub_E8A
		jr	nc, loc_E81
		call	sub_E97
		jr	loc_E82
loc_E81:	add	hl, de
loc_E82:	push	hl
		pop	iy
loc_E85:	ld	(current), iy	; aktuelle Adr.	(im Z80-Adressraum)
		ret

sub_E8A:	push	iy
		pop	hl
		ld	d, 0
		ld	e, (iy-1)
		rlc	e
		rrc	e
		ret

sub_E97:	ld	a, e
		cpl
		inc	a
		ld	e, a
		scf
		ccf
		sbc	hl, de
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

c42_or:		call	sub_F6B
		or	b
loc_EA4:	ld	(hl), a
loc_EA5:	call	loc_B02
		ld	hl, reg_Flags
		res	4, (hl)
		jp	sub_B94

c43_or:		call	sub_F74
		or	b
		jr	loc_EA4

c52_and:	call	sub_F6B
		and	b
		jr	loc_EA4

c53_and:	call	sub_F74
		and	b
		jr	loc_EA4

cb2_xor:	call	sub_F6B
		xor	b
		jr	loc_EA4

cb3_xor:	call	sub_F74
		xor	b
		jr	loc_EA4

c62_tcm:	call	sub_F6B
		ld	c, a
		ld	a, b
		cpl
		ld	b, c
		and	b
		jr	loc_EA5

c63_tcm:	call	sub_F74
		cpl
		and	b
		jr	loc_EA5

c72_tm:		call	sub_F6B
		ld	c, a
		ld	a, b
		ld	b, c
		and	b
		jr	loc_EA5

c73_tm:		call	sub_F74
		and	b
		jr	loc_EA5

c60_com:	call	f_R
loc_EF1:	ld	a, (hl)
		cpl
loc_EF3:	ld	(hl), a
		inc	(hl)
		dec	(hl)
		jr	loc_EA4

c61_com:	call	f_R
		ld	l, (hl)
		jr	loc_EF1

c40_da:		call	p_R
		ld	a, (de)
loc_F02:	daa
		call	loc_AF3
		ld	(de), a
		ex	de, hl
		jr	loc_EF3

c41_da:		call	p_R
		ld	a, (de)
		ld	e, a
		jr	loc_F02

ca2_cp:		call	sub_F6B
loc_F14:	cpl
		cp	b
		call	sub_AE4
		jp	loc_B8E

ca3_cp:		call	sub_F74
		jr	loc_F14

c02_add:	call	sub_F6B
		add	a, b
loc_F25:	ld	(hl), a
		call	sub_AD5
		ld	hl, reg_Flags
		res	3, (hl)
		jp	sub_B94

c03_add:	call	sub_F74
		add	a, b
		jr	loc_F25

c12_adc:	call	sub_F6B
		adc	a, b
		jr	loc_F25

c13_adc:	call	sub_F74
		adc	a, b
		jr	loc_F25

c22_sub:	call	sub_F6B
		ld	c, a
		ld	a, b
		ld	b, c
		sub	b
loc_F4A:	ld	(hl), a
		call	sub_AD5
		ld	hl, reg_Flags
		set	3, (hl)
		jp	sub_B94

c23_sub:	call	sub_F74
		sub	b
		jr	loc_F4A

c32_sbc:	call	sub_F6B
		ld	c, a
		ld	a, b
		ld	b, c
		sbc	a, b
		jr	loc_F4A

c33_sbc:	call	sub_F74
		sbc	a, b
		jr	loc_F4A

sub_F6B:	call	flags		; flags	setzen
		call	sub_B72
		ld	b, (hl)
		ld	a, (de)
		ret

sub_F74:	call	sub_F6B
		ld	e, a
		ld	a, (de)
		ld	c, a
		ld	a, b
		ld	b, c
		ret

c8b_jr:		call	sub_B94
		call	sub_E8A
		jr	nc, loc_F8A
		call	sub_E97
		jr	loc_F8B
loc_F8A:	add	hl, de
loc_F8B:	push	hl
		pop	iy
		ld	(current), iy	; aktuelle Adr.	(im Z80-Adressraum)
		ret

c0b_jr:		call	sub_B94
		ret

c7b_jr:		ld	hl, reg_Flags
		bit	7, (hl)
loc_F9C:	jr	nz, c8b_jr
		jr	c0b_jr

cfb_jr:		ld	hl, reg_Flags
		bit	7, (hl)
loc_FA5:	jr	z, c8b_jr
		jr	c0b_jr

c6b_jr:		ld	hl, reg_Flags
		bit	6, (hl)
		jr	loc_F9C

ceb_jr:		ld	hl, reg_Flags
		bit	6, (hl)
		jr	loc_FA5

cdb_jr:		ld	hl, reg_Flags
		bit	5, (hl)
		jr	loc_FA5

c5b_jr:		ld	hl, reg_Flags
		bit	5, (hl)
		jr	loc_F9C

c4b_jr:		ld	hl, reg_Flags
		bit	4, (hl)
		jr	loc_F9C

ccb_jr:		ld	hl, reg_Flags
		bit	4, (hl)
		jr	loc_FA5

c1b_jr:		call	sub_FF2
		jr	loc_F9C

c9b_jr:		call	sub_FF2
		jr	loc_FA5

c2b_jr:		call	sub_FF2
		ld	b, a
		ld	a, (hl)
		and	40h ; '@'
		or	b
		jr	loc_F9C

cab_jr:		call	sub_FF2
		ld	b, a
		ld	a, (hl)
		and	40h ; '@'
		or	b
		jr	loc_FA5
		db    0

sub_FF2:	ld	hl, reg_Flags
		ld	a, (hl)
		and	20h ; ' '
		ld	b, a
		ld	a, (hl)
		and	10h
		rlca
		xor	b
		ret
		db    0

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

		org 1000h


c3b_jr:		call	sub_100A
		jr	loc_F9C

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

vbb_jr:		call	sub_100A
		jr	loc_FA5
sub_100A:	ld	hl, reg_Flags
		ld	a, (hl)
		and	80h
		ld	b, a
		ld	a, (hl)
		and	40h
		nop
		or	b
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

c80_decw:	call	p_R
		ex	de, hl
loc_101B:	ld	b, (hl)
		inc	hl
		ld	c, (hl)
		dec	bc
		ld	(hl), c
		dec	hl
		ld	(hl), b
		inc	bc
		push	bc
		pop	hl
		ld	bc, 1
		or	a
		sbc	hl, bc
loc_102B:	push	af
		pop	bc
		call	loc_B02
		ld	hl, reg_Flags
		res	4, (hl)
		bit	2, c
		jr	z, loc_103B
		set	4, (hl)
loc_103B:	jp	sub_B94

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

c81_decw:	call	p_R
		ex	de, hl
		ld	l, (hl)
		jr	loc_101B

ca0_incw:	call	p_R
		ex	de, hl
loc_1049:	ld	b, (hl)
		inc	hl
		ld	c, (hl)
		inc	bc
		ld	(hl), c
		dec	hl
		ld	(hl), b
		dec	bc
		push	bc
		pop	hl
		ld	bc, 1
		or	a
		adc	hl, bc
		jr	loc_102B

ca1_incw:	call	p_R
		ex	de, hl
		ld	l, (hl)
		jr	loc_1049

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

ce3_ld:		call	sub_B72
		ld	a, (de)
		ld	e, a
		ld	a, (de)
		ld	(hl), a
		jp	sub_B94

cf3_ld:		call	sub_B72
		ld	a, (hl)
		ld	l, a
		ld	a, (de)
		ld	(hl), a
		jp	sub_B94

c92_lde:	call	sub_B72
		ld	b, (hl)
		inc	hl
		ld	c, (hl)
		ld	a, (de)
		nop
		ld	hl, emrprog
		add	hl, bc
		ld	(hl), a
		jp	sub_B94

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

cd6_call:	call	sub_10AB
		inc	de
		call	sub_11FE
		ld	b, (iy+1)
		ld	c, (iy+2)
		jr	loc_10A3

		db    0
		db    0

cd4_call:	call	sub_10AB
		call	sub_11FE
		call	loc_B52
		ld	b, (hl)
		inc	hl
		ld	c, (hl)
loc_10A3:	ld	hl, emrprog
		add	hl, bc
		ld	(current), hl	; aktuelle Adr.	(im Z80-Adressraum)
		ret

sub_10AB:	ld	h, hi(register)
		ld	a, (reg_SPL)	; Stack	Pointer
		ld	l, a
		dec	hl
		dec	hl
		ld	a, l
		ld	(reg_SPL), a	; Stack	Pointer
		ld	de, (current)	; aktuelle Adr.	(im Z80-Adressraum)
		inc	de
		inc	de
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

c30_jp:		call	p_R
		ex	de, hl
		ld	d, (hl)
		inc	hl
		ld	e, (hl)
		ld	hl, emrprog
		add	hl, de
		ld	(current), hl	; aktuelle Adr.	(im Z80-Adressraum)
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

caf_ret:	ld	hl, reg_SPL	; Stack	Pointer
		ld	l, (hl)
		ld	b, (hl)
		inc	hl
		ld	c, (hl)
		inc	hl
		ld	a, l
		ld	(reg_SPL), a	; Stack	Pointer
		ld	hl, emrprog
		add	hl, bc
		ld	(current), hl	; aktuelle Adr.	(im Z80-Adressraum)
		ret

		db    0
		db    0
		db    0
		db    0

cbf_iret:	ld	hl, reg_IMR	; Interrupt mask reg.
		set	7, (hl)
		ld	hl, reg_SPL	; Stack	Pointer
		ld	l, (hl)
		ld	a, (hl)
		ld	(reg_Flags), a
		ld	hl, reg_SPL	; Stack	Pointer
		inc	(hl)
		jr	caf_ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

cd7_ld:		call	sub_B72
		ld	b, (iy+2)
		ld	a, (de)
		add	a, b
		ld	e, a
		ld	a, (hl)
		ld	(de), a
		jr	c0d_jp

cc7_ld:		call	sub_B72
		ex	de, hl
		ld	a, (iy+2)
		add	a, (hl)
		ld	l, a
		ld	a, (hl)
		ld	(de), a
		jp	loc_B8E

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

c8d_jp:		ld	hl, emrprog
		ld	d, (iy+1)
		ld	e, (iy+2)
		add	hl, de
		push	hl
		pop	iy
		ld	(current), iy	; aktuelle Adr.	(im Z80-Adressraum)
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

c0d_jp:		jp	loc_B8E

c7d_jp:		ld	hl, reg_Flags
		bit	7, (hl)
loc_112D:	jr	nz, c8d_jp
		jr	c0d_jp

cfd_jp:		ld	hl, reg_Flags
		bit	7, (hl)
loc_1136:	jr	z, c8d_jp
		jr	c0d_jp

c6d_jp:		ld	hl, reg_Flags
		bit	6, (hl)
		jr	loc_112D

ced_jp:		ld	hl, reg_Flags
		bit	6, (hl)
		jr	loc_1136

cdd_jp:		ld	hl, reg_Flags
		bit	5, (hl)
		jr	loc_1136

c5d_jr:		ld	hl, reg_Flags
		bit	5, (hl)
		jr	loc_112D

c4d_jp:		ld	hl, reg_Flags
		bit	4, (hl)
		jr	loc_112D

ccd_jr:		ld	hl, reg_Flags
		bit	4, (hl)
		jr	loc_1136

c1d_jp:		call	sub_FF2
		jr	loc_112D

c9d_jp:		call	sub_FF2
		jr	loc_1136

c3d_jp:		call	sub_100A
		jr	loc_112D

cbd_jp:		call	sub_100A
		jr	loc_1136

c2d_jr:		call	sub_FF2
		ld	b, a
		ld	a, (hl)
		and	40h
		or	b
		jr	loc_112D

cad_jp:		call	sub_FF2
		ld	b, a
		ld	a, (hl)
		and	40h
		or	b
		jr	loc_1136

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

c83_ldei:	call	sub_B72
		push	hl
		push	de
		ld	l, (hl)
		ld	a, (reg_RP)	; Register Pointer
		add	a, l
		ld	l, a
		push	hl
		push	de
		pop	hl
		ld	a, (hl)
		add	a, hi(emrprog)
		ld	b, a
		inc	hl
		ld	c, (hl)
		ld	a, (bc)
		pop	hl
		ld	(hl), a
		jr	loc_11BD

c93_ldei:	call	sub_B72
		push	de
		push	hl
		ld	b, (hl)
		inc	hl
		ld	c, (hl)
		ld	hl, emrprog
		add	hl, bc
		push	hl
		pop	bc
		push	de
		pop	hl
		ld	a, (reg_RP)	; Register Pointer
		ld	d, (hl)
		or	d
		ld	l, a
		ld	a, (hl)
		ld	(bc), a
loc_11BD:	pop	hl
		ld	d, (hl)
		inc	hl
		ld	c, (hl)
		inc	bc
		ld	a, b
		sub	hi(emrprog)
		ld	b, a
		ld	(hl), c
		dec	hl
		ld	(hl), b
		pop	hl
		inc	(hl)
		jp	sub_B94


;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------
; Vorgabe Systemregister F0..FF

sysregtab:	db 0FFh
		db    0
		db 0FFh
		db 0FCh	; 
		db 0FFh
		db 0FEh	; 
		db 0FFh
		db    2
		db  4Dh	; M
		db 0FFh
		db    0
		db  7Fh	; 
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

c82_lde:	call	sub_B72
		ex	de, hl
		ld	b, (hl)
		inc	hl
		ld	c, (hl)
		ld	hl, emrprog
		add	hl, bc
		ld	a, (hl)
		ld	(de), a
		jp	sub_B94

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

c0f:		ld	a, 0Fh		; single step
		jr	loc_11F8

c1f:		ld	a, 1Fh		; trace
		jr	loc_11F8

c2f:		ld	a, 2Fh
loc_11F8:	ld	(autorun), a	; autorun
		jp	loc_B9A

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

sub_11FE:	push	hl
		push	de
		pop	hl
		ld	de, emrprog
		or	a
		sbc	hl, de
		push	hl
		pop	de
		pop	hl
		ld	(hl), d
		inc	hl
		ld	(hl), e
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

ports:		call	TWOSEG		; Umwandlung 2 Ziffern zur Anzeige
					; Rest von STEP, vermutlich reingepatcht

		ld	a, 0FFh
		out	(0FAh),	a
		ld	a, (reg_P2M)	; Port 2 mode
		out	(0FAh),	a
		ld	a, (reg_p2)	; Port 2
		out	(0F8h),	a
		in	a, (0F8h)
		ld	b, a
		ld	a, (reg_P2M)	; Port 2 mode
		and	b
		ld	c, a
		ld	a, (reg_p2)	; Port 2
		ld	b, a
		ld	a, (reg_P2M)	; Port 2 mode
		cpl
		and	b
		or	c
		cpl
		ld	b, a
		ld	a, 0FFh
		xor	b
		ld	(reg_p2), a	; Port 2
		ret

;------------------------------------------------------------------------------
; RAM
;------------------------------------------------------------------------------


startadr:	equ	2003h	; ds 2
unk_2005:	equ	2005h		; auszugebendes	Register 1
unk_2006:	equ	2006h		; auszugebendes	Register 2
unk_2007:	equ	2007h		; auszugebendes	Register 3
autorun:	equ	2008h		; 0F=autorun, sonst 1F

Register:	equ	2100h		; mus xx00h-Adresse sein
reg_p2:		equ	Register+2	; Port 2

;Pseudoregister (liegen hier zwecks einfacher Anzeige im Trace)
current:	equ	2180h		; aktuelle Adr.	(im Z80-Adressraum)
stepcnt:	equ	2182h

sysregister:	equ	Register+0F0h
reg_P2M:	equ	Register+0F6h	; Port 2 mode
reg_IMR:	equ	Register+0FBh	; Interrupt mask reg.
reg_Flags:	equ	Register+0FCh
reg_RP:		equ	Register+0FDh	; Register Pointer
reg_SPL:	equ	Register+0FFh	; Stack	Pointer

;230Eh		c3f_register, Registernr fr Anzeige bei code 3F
;2310h		step-routine, da diese im RAM stehen muss und modifiziert wird

; das Z8-Programm
emrprog:	equ	2400h


		end

#------------------------------------------------------------------------------
# EMR-Simulator f. LC-80
#------------------------------------------------------------------------------

emuliert einen Z8-Prozessor (U881)

keine Unterscheidung CODE-Speicher, RAM-Speicher (lde, ldc)
Register liegen im RAM, Arithmetik etc. wird ber Z80-Register A erledigt
Flags werden gesetzt/beachtet.
ein ungltiger OP-Code dient als Simulator-Befehl.

braucht 
	- 2K-System
	- 4K ROM EMRSIM
	- 2K RAM-Erweiterung

0000-07FF	2Kx1 - System
0800-123F 	4K EMRSim

2000-23FF	1K RAM
2400-2BFF	2K RAM f. Z8-Programm

Z8-Programm liegt auf Adr 2400h

Speicheradr.

2003h		Startadr Z8-Program (relativ, also z.B. 000c)
2008h		0F dann single step, 1F trace

2100-217F	Z8-Register
21F0-21FF	Z8-Systemregister

Benutzung

start auf Adr. 0800
Z8-Programm wird auf Adr (2003/4) + 2400h gelesen und gestartet
Bei trace luft das Programm autom. durch, nach jedem Z8-Befehl erfolgt eine kurze Anzeige.
dreier Registerinhalte (Reg.Nr. in 2005..2007)
bei single step danach Warten auf Tastendruck.

Z8-Spezialbefehle
	0f	; spezial code: single step
	1f	; spezial code: trace
	2f	; spezial code: autorun
	3f	; spezial code: registeranzeige

registeranzeige:
Der Emulator wird angehalten und der Inhalt eines Registers angezeigt.
+,- schaltet die Register weiter
ADR Registernummer editieren
DAT Registerwert editieren
0..F ndert den Registerwert
EX beendet die Registeranzeige und setzt das Programm fort

Z8-Spezial Port 2 wird emuliert -> USERPORT

